;20-12-2018 +add buttons for scroll,+Ctrl+I - Invert
;22-12-18 +fix for display b/w picture
;29-07-2002 1.01j
; add fill attributes by b1
;fixed find countour error
;16-11-2023 open file 6144 bytes, fix images

;UsePNGImageDecoder()
Global *track=AllocateMemory(6912)
Global trdf.s=""
Global *filemem=AllocateMemory(6912*3)
Global *tmpbuf=AllocateMemory(6912)
Global filetosave.s=""
Global Dim scradrs.u(191)
Global Dim hm.a(255)
Global howtosave=-1
Global trdofs=-1
Global Dim hobh.a(14)

Global Dim brush(12)
Global Dim scra.w(192)

Enumeration
  #save_none
  #save_scr
  #save_trd
  #save_scl
  #save_hob
EndEnumeration

Enumeration
  #MENU_OPEN
  #MENU_SAVE
  #MENU_SAVEAS
  #MENU_QUIT
  #MENU_OPTIMI
  #MENU_OPTIMI2
  #MENU_INVERT
  #MENU_SPLIT
  #MENU_CONTOUR
  #MENU_MASK
  #MENU_MIRRORH
  #MENU_MIRRORV
  
  #MENU_UNDO
  ;view
  #MENU_VIEW_N
  #MENU_VIEW_I
  #MENU_VIEW_P
EndEnumeration

;- Gadget Constants
;
Enumeration
  #Image_0
  #Image_1
  #CheckBox_Correct
  #CheckBox_Grid
  #Field_b1
  #Field_b2
  #combo_b1b2
  #btn_go
  #panel
  ;trd gadgets
  #dsk
  #pview
  #fltr
  ;for color mode
  #radio_n
  #radio_i
  #radio_p
  ;combo_box pick colors
  #combo_p1
  #combo_p2
  ;buttons for scroll
  #bsl
  #bsr
  #bsd
  #bsu
EndEnumeration

Procedure drawzx(crx.i,cry.i)
  isgrid=GetGadgetState(#CheckBox_Grid)
  
  am.a=$FF;mask for attributes
  If GetGadgetState(#radio_i):am=%11000111:EndIf
  If GetGadgetState(#radio_p):am=%11111000:EndIf
  
  zoo=2
  For ca=0 To 1
    StartDrawing(CanvasOutput((#Image_0+ca)))
    For t=0 To 2  
      For k=0 To 7
        For i=0 To 255
          zxatr.b=PeekB(*filemem+i+t*256+6144)
          aa.b=PeekB(*filemem+i+k*256+t*2048)
          bb.s=RSet(Bin(aa,#PB_Byte),8,"0")
          
          ;zxatr=zxatr&%11000111
          zxatr=zxatr&am;;%11111000
          If ca=0
            zxatr=$38;7 fixes
          EndIf
          
          If cry*32+crx =i+t*256
            zxatr=255-zxatr
          EndIf
          
          For j=0 To 7
            
            If Mid(bb.s,j+1,1)="0"
              papi=(zxatr>>3)&7
              colwei=127
              
              If zxatr&64
                colwei=255
              EndIf
              
              papr.a=((papi>>1)&1)*colwei
              papb.a=(papi&1)*colwei
              papg.a=((papi>>2)&1)*colwei
              colr=RGB(papr,papg,papb)
            Else
              
              inki=zxatr&7
              colwei=127
              If zxatr&64
                colwei=255
              EndIf
              
              inkr.a=((inki>>1)&1)*colwei
              inkb.a=(inki&1)*colwei
              inkg.a=((inki>>2)&1)*colwei
              colr=RGB(inkr,inkg,inkb)
            EndIf
            y=Int(i/32)*8+k+t*64
            x=(i%32)*8+j
            Box(x*zoo,y*zoo,2,2,colr)
          Next j
          
          
          
        Next i
      Next k
    Next t
    
    If isgrid
      For x=0 To 31
        LineXY(16*x,0,16*x,384,RGB(0,0,255))
      Next x
      
      For y=0 To 23
        LineXY(0,16*y,512,16*y,RGB(0,0,255))
      Next y
      
    EndIf
    
    
    StopDrawing()
  Next ca
  
EndProcedure

Procedure.u down_hl(hl.u)
  h.a=hl>>8
  l.a=hl&255
  h=h+1
  If h&7=0
    l1.a=l
    l=l+32
    If (l1+32)>>8=0
      h=h-8
    EndIf
  EndIf
  hl=h*256+l
  ProcedureReturn hl
EndProcedure

Procedure draw_zx()
  
  zoo=1
  
  StartDrawing(CanvasOutput(#pview))
  Box(0,0,256*zoo, 192*zoo,0)
  
  For t=0 To 2  
    For k=0 To 7
      For i=0 To 255
        zxatr.a=PeekA(*track+i+t*256+6144)
        aa.a=PeekA(*track+i+k*256+t*2048)
        
        bw.a=128
        For j=0 To 7
          
          If Not aa&bw;Mid(bb.s,j+1,1)="0"
            papi=(zxatr>>3)&7
            colwei=192
            
            If zxatr&64
              colwei=255
            EndIf
            
            papr.a=((papi>>1)&1)*colwei
            papb.a=(papi&1)*colwei
            papg.a=((papi>>2)&1)*colwei
            colr=RGB(papr,papg,papb)
          Else
            inki=zxatr&7
            colwei=192
            If zxatr&64
              colwei=255
            EndIf
            
            inkr.a=((inki>>1)&1)*colwei
            inkb.a=(inki&1)*colwei
            inkg.a=((inki>>2)&1)*colwei
            colr=RGB(inkr,inkg,inkb)
          EndIf
          
          y=Int(i/32)*8+k+t*64
          x=(i%32)*8+j
          Box(x*zoo,y*zoo,zoo,zoo,colr)
          
          bw=bw>>1
        Next j
      Next i
    Next k
  Next t
  
  StopDrawing()
EndProcedure


Procedure.a getpixel(x.a,y.a)
  ; Get screen address 
  ; 2 ; B = Y pixel position 
  ; 3 ; C = X pixel position 
  ; 4 ; Returns address in HL 
  ; 5 Get_Pixel_Address:  LD A,B          ; Calculate Y2,Y1,Y0 
  ; 6                     And %00000111   ; Mask out unwanted bits 
  ; 7                     Or %01000000    ; Set base address of screen 
  ; 8                     LD H,A          ; Store in H 
  ; 9                     LD A,B          ; Calculate Y7,Y6 
  ; 10                     RRA             ; Shift to position 
  ; 11                     RRA 
  ; 12                     RRA 
  ; 13                     And %00011000   ; Mask out unwanted bits 
  ; 14                     Or H            ; OR with Y2,Y1,Y0 
  ; 15                     LD H,A          ; Store in H
  
  ; 16                     LD A,B          ; Calculate Y5,Y4,Y3 
  ; 17                     RLA             ; Shift to position 
  ; 18                     RLA 
  ; 19                     And %11100000   ; Mask out unwanted bits 
  ; 20                     LD L,A          ; Store in L 
  ; 21                     LD A,C          ; Calculate X4,X3,X2,X1,X0 
  ; 22                     RRA             ; Shift into position 
  ; 23                     RRA 
  ; 24                     RRA 
  ; 25                     And %00011111   ; Mask out unwanted bits 
  ; 26                     Or L            ; OR with Y5,Y4,Y3 
  ; 27                     LD L,A          ; Store in L 
  ; 28                     RET 
  h.a=( y & %00000111 )
  h=h|((y>>3)&%00011000)
  l.a=(y<<2)& %11100000
  l=l|( (x>>3)&%00011111 )
  
  res.a=PeekA( *filemem+h*256+l)&(128>>(x&7) )
  ProcedureReturn res
EndProcedure

Procedure putpixel(x.a,y.a)
  ; Get screen address 
  ; 2 ; B = Y pixel position 
  ; 3 ; C = X pixel position 
  ; 4 ; Returns address in HL 
  ; 5 Get_Pixel_Address:  LD A,B          ; Calculate Y2,Y1,Y0 
  ; 6                     And %00000111   ; Mask out unwanted bits 
  ; 7                     Or %01000000    ; Set base address of screen 
  ; 8                     LD H,A          ; Store in H 
  ; 9                     LD A,B          ; Calculate Y7,Y6 
  ; 10                     RRA             ; Shift to position 
  ; 11                     RRA 
  ; 12                     RRA 
  ; 13                     And %00011000   ; Mask out unwanted bits 
  ; 14                     Or H            ; OR with Y2,Y1,Y0 
  ; 15                     LD H,A          ; Store in H
  
  ; 16                     LD A,B          ; Calculate Y5,Y4,Y3 
  ; 17                     RLA             ; Shift to position 
  ; 18                     RLA 
  ; 19                     And %11100000   ; Mask out unwanted bits 
  ; 20                     LD L,A          ; Store in L 
  ; 21                     LD A,C          ; Calculate X4,X3,X2,X1,X0 
  ; 22                     RRA             ; Shift into position 
  ; 23                     RRA 
  ; 24                     RRA 
  ; 25                     And %00011111   ; Mask out unwanted bits 
  ; 26                     Or L            ; OR with Y5,Y4,Y3 
  ; 27                     LD L,A          ; Store in L 
  ; 28                     RET 
  h.a=( y & %00000111 )
  h=h|((y>>3)&%00011000)
  l.a=(y<<2)& %11100000
  l=l|( (x>>3)&%00011111 )
  
  PokeA(*filemem+h*256+l,PeekA(*filemem+h*256+l)|(128>>(x&7)) )
EndProcedure

Procedure.s addext(fn.s,ex.s)
  ;;  Debug "res:"+Mid(fn,Len(fn)-Len(ex))
  If LCase( Mid(fn,Len(fn)-Len(ex)) )<>"."+ex
    fn=fn+"."+ex
  EndIf
  ;  Debug fn
  ProcedureReturn fn
EndProcedure

Procedure WndProc(hwnd, uMsg, wParam, lParam)
  
  Result = #PB_ProcessPureBasicEvents 
  
  Select uMsg
      
    Case #WM_DRAWITEM 
      *DRAWITEM.DRAWITEMSTRUCT = lParam       
      If *DRAWITEM\CtlType = #ODT_COMBOBOX
        id = *DRAWITEM\itemID 
        If id >= 0 And *DRAWITEM\CtlID = #combo_p1
          InflateRect_(*DRAWITEM\rcItem,-1,-1)        
          FillRect_(*DRAWITEM\hDC,*DRAWITEM\rcItem,brush(id))
          FrameRect_(*DRAWITEM\hDC,*DRAWITEM\rcItem,brush(11))
        ElseIf id >= 0 And *DRAWITEM\CtlID = #combo_p2
          InflateRect_(*DRAWITEM\rcItem,-1,-1)        
          FillRect_(*DRAWITEM\hDC,*DRAWITEM\rcItem,brush(id))
          FrameRect_(*DRAWITEM\hDC,*DRAWITEM\rcItem,brush(11))
        EndIf
      EndIf
      
  EndSelect 
  
  ProcedureReturn Result 
EndProcedure 

; Open_Window_0()
howtosave=-1
trdofs=-1
If OpenWindow(0, 381, 118, 1073, 510, "Screen Optimizer 1.0j",  #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar|#PB_Window_MinimizeGadget)
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#MENU_OPEN, "Open.."+Chr(9)+"Ctrl+O")
    MenuItem(#MENU_SAVE, "Save"+Chr(9)+"Ctrl+S")
    MenuItem(#MENU_SAVEAS, "Save As..")
    MenuBar()
    MenuItem(#MENU_QUIT, "Quit"+Chr(9)+"Ctrl+Q")
    MenuTitle("Operations")
    MenuItem(#MENU_OPTIMI, "Optimize(old)")
    MenuItem(#MENU_OPTIMI2, "Optimize(NEW)")
    MenuItem(#MENU_INVERT, "Invert"+Chr(9)+"Ctrl+I")
    MenuItem(#MENU_SPLIT, "Split picture+attributes")
    MenuItem(#MENU_CONTOUR, "Find contour")
    MenuItem(#MENU_MASK, "Create Mask")
    MenuBar()
    MenuItem(#MENU_MIRRORH, "Mirror Horisontal")
    MenuItem(#MENU_MIRRORV, "Mirror Vertical")
    ;CloseSubMenu()
    MenuTitle("View")
    MenuItem(#MENU_VIEW_N, "Normal"+Chr(9)+"Alt+1")
    MenuItem(#MENU_VIEW_I, "ink"+Chr(9)+"Alt+2")
    MenuItem(#MENU_VIEW_P, "paper"+Chr(9)+"Alt+3")
    CloseSubMenu()
    MenuItem(#MENU_UNDO,"Undo")
    ;DisableMenuItem(0,#MENU_UNDO, 1);1-disable,0-enable
  EndIf
  AddKeyboardShortcut(0, #PB_Shortcut_Alt | #PB_Shortcut_1, #MENU_VIEW_N)
  AddKeyboardShortcut(0, #PB_Shortcut_Alt | #PB_Shortcut_2, #MENU_VIEW_I)
  AddKeyboardShortcut(0, #PB_Shortcut_Alt | #PB_Shortcut_3, #MENU_VIEW_P)
  
  AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_I, #MENU_INVERT)
  
  
  ;calc adresses
  p=0
  For k=0 To 2;2048
    For j=0 To 7;0..31,32..63
      For i=0 To 7;$4000..$4700
        hl.u=i*256+j*32+k*2048
        ;Debug Hex(16384+hl)
        scra(p)=hl
        p+1
      Next i
    Next j
  Next k
  
  ;-----build gadgets-----
  
  PanelGadget(#panel,0,0,1073,510)
  AddGadgetItem (#panel, -1, "Image")
  
  CanvasGadget(#Image_0, 0, 20, 512, 384, #PB_Canvas_ClipMouse);|#PB_Canvas_Border)
  CanvasGadget(#Image_1, 530, 20, 512, 384, #PB_Canvas_ClipMouse);|#PB_Canvas_Border)
  
  CheckBoxGadget(#CheckBox_Grid, 0, 0, 80, 20, "Grid")
  
  OptionGadget(#radio_n,100,0,80,20,"Normal(1)")
  OptionGadget(#radio_i,180,0,80,20,"ink(2)")
  OptionGadget(#radio_p,260,0,80,20,"paper(3)")
  SetGadgetState(#radio_n,1)
  
  StringGadget(#Field_b1,0,405,40,20,"b1"):GadgetToolTip(#Field_b1,"b1")
  
  ComboBoxGadget(#combo_p1,0,425,40,20,#CBS_OWNERDRAWFIXED)
  
  ComboBoxGadget(#combo_p2,200,425,40,20,#CBS_OWNERDRAWFIXED)
  
  For x = 0 To 7
    r.a=0
    g.a=0
    b.a=0
    If x&1:b=255:EndIf
    If x&2:r=255:EndIf
    If x&4:g=255:EndIf
    col.l=RGB(r,g,b)
    brush(x) = CreateSolidBrush_(col)
    AddGadgetItem(#combo_p1,-1, "")
    AddGadgetItem(#combo_p2,-1, "")
  Next
  
  SendMessage_(GadgetID(#combo_p1),#CB_SETITEMHEIGHT,0,24)
  SendMessage_(GadgetID(#combo_p2),#CB_SETITEMHEIGHT,0,24)
  
  ComboBoxGadget(#combo_b1b2,40,405,160,20)
  AddGadgetItem(#combo_b1b2,-1,"choose byte operations")
  AddGadgetItem(#combo_b1b2,-1,"b1 replace to b2");1
  AddGadgetItem(#combo_b1b2,-1,"b1 AND b2")       ;2
  AddGadgetItem(#combo_b1b2,-1,"b1 OR b2")        ;3
  AddGadgetItem(#combo_b1b2,-1,"b1 EOR(xor) b2")  ;4
  AddGadgetItem(#combo_b1b2,-1,"Change ink b1 to b2");5
  AddGadgetItem(#combo_b1b2,-1,"Change paper b1 to b2");6
  AddGadgetItem(#combo_b1b2,-1,"Change both ink/paper b1 to b2");7
  AddGadgetItem(#combo_b1b2,-1,"Fill attributes by b1")         ;9
  
  SetGadgetState(#combo_b1b2,0)
  StringGadget(#Field_b2,200,405,40,20,"b2"):GadgetToolTip(#Field_b2,"b2")
  ButtonGadget(#btn_go,240,405,40,20,"go!")
  
  ;scroller buttons
  CatchImage(50,?isl)
  ButtonImageGadget(#bsl, 280, 405, 20, 20, ImageID(50)):GadgetToolTip(#bsl,"scroll character left")
  CatchImage(51,?isu)
  ButtonImageGadget(#bsu, 300, 405, 20, 20, ImageID(51)):GadgetToolTip(#bsu,"scroll character up")
  CatchImage(52,?isd)
  ButtonImageGadget(#bsd, 320, 405, 20, 20, ImageID(52)):GadgetToolTip(#bsd,"scroll character down")
  CatchImage(53,?isr)
  ButtonImageGadget(#bsr, 340, 405, 20, 20, ImageID(53)):GadgetToolTip(#bsr,"scroll character right")
  
  
  AddGadgetItem (#panel, -1, "TRD")
  ListIconGadget(#dsk, 256, 0, 390, 200, "Name", 100, #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
  CanvasGadget(#pview,0,0,256,192,#PB_Canvas_Border)
  CheckBoxGadget(#fltr,650,0,40,20,"f"):GadgetToolTip(#fltr,"filter only screens"):SetGadgetState(#fltr,1)
  AddGadgetColumn(#dsk, 1, "T", 40);type
  AddGadgetColumn(#dsk, 2, "StA", 50);start Address
  AddGadgetColumn(#dsk, 3, "Size", 50);Size
  AddGadgetColumn(#dsk, 4, "Trk", 40) ;Start track
  AddGadgetColumn(#dsk, 5, "Sect", 40);Start sector
EndIf

EnableGadgetDrop(#Image_0, #PB_Drop_Files,#PB_Drag_Copy)
EnableGadgetDrop(#Image_1, #PB_Drop_Files,#PB_Drag_Copy)

EnableGadgetDrop(#dsk, #PB_Drop_Files,#PB_Drag_Copy)

AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_O, #MENU_OPEN)
AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_S, #MENU_SAVE)
AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_Q, #MENU_QUIT)

SetWindowCallback(@WndProc())

If CountProgramParameters()=1
  fn.s=ProgramParameter(0)
  ; Debug fn
  If FileSize(fn)>0 And FileSize(fn)=6912
    ReadFile(0,fn)
    ReadData(0,*filemem,6912)
    CloseFile(0)
    drawzx(-1,-1)
    filetosave=fn
    howtosave=#save_scr
  EndIf
EndIf

hl.u=0
For y=0 To 191
  scradrs(y)=hl
  hl=down_hl(hl)
Next y

For i=0 To 255
  bb.a=i
  cc.a=0
  bw1.a=128
  bw2.a=1
  For j=0 To 7
    If bb&bw1
      cc=cc|bw2
    EndIf
    bw1=bw1>>1
    bw2=bw2<<1
  Next j
  hm(i)=cc
Next i

Repeat
  Event = WaitWindowEvent()
  If GetAsyncKeyState_(#VK_ESCAPE)&32768
    Break
  EndIf
  ;----------------Handle Menu
  Select Event
    Case #PB_Event_Menu
      Select EventMenu()
        Case #MENU_VIEW_N
          SetGadgetState(#radio_n,1)
          SetGadgetState(#radio_i,0)
          SetGadgetState(#radio_p,0)
          drawzx(-1,-1)
        Case #MENU_VIEW_I
          SetGadgetState(#radio_n,0)
          SetGadgetState(#radio_i,1)
          SetGadgetState(#radio_p,0)
          drawzx(-1,-1)
        Case #MENU_VIEW_P
          SetGadgetState(#radio_n,0)
          SetGadgetState(#radio_i,0)
          SetGadgetState(#radio_p,1)
          drawzx(-1,-1)
          
          
        Case #MENU_UNDO
          ;       Debug "undo"
          CopyMemory (*filemem+6912,*filemem,6912)
          drawzx(-1,-1)
        Case #MENU_MIRRORV
          CopyMemory (*filemem,*filemem+6912,6912)
          For y=0 To 95
            hl1.u=scradrs(y)
            hl2.u=scradrs(191-y)
            For x=0 To 31
              a1.a=PeekA(*filemem+hl1+x)
              a2.a=PeekA(*filemem+hl2+x)
              PokeA(*filemem+hl2+x,a1)
              PokeA(*filemem+hl1+x,a2)
            Next x
          Next y
          For y=0 To 11
            For x=0 To 31
              a1.a=PeekA(*filemem+6144+x+y*32)
              a2.a=PeekA(*filemem+6144+x+(23-y)*32)
              PokeA(*filemem+6144+x+y*32,a2)
              PokeA(*filemem+6144+x+(23-y)*32,a1)
            Next x
          Next y
          
          drawzx(-1,-1)
        Case #MENU_MIRRORH
          CopyMemory (*filemem,*filemem+6912,6912)
          hl.u=0
          atrd.u=$1800
          For y=0 To 191
            For x=0 To 15
              cc.a=hm(PeekA(*filemem+hl+x));left
              bb.a=hm(PeekA(*filemem+hl+31-x));right
              PokeA(*filemem+hl+31-x,cc)
              PokeA(*filemem+hl+x,bb)
            Next x
            hl=down_hl(hl)
          Next y
          
          For y=0 To 23
            For x=0 To 15
              cc.a=PeekA(*filemem+atrd+x);left
              bb.a=PeekA(*filemem+atrd+31-x);right
              PokeA(*filemem+atrd+31-x,cc)
              PokeA(*filemem+atrd+x,bb)
            Next x
            atrd+32
          Next y
          drawzx(-1,-1)
          
        Case #MENU_MASK
          CopyMemory (*filemem,*filemem+6912,6912)
          ;scroll right
          hl.u=0  
          For y=0 To 191
            cy.a=0
            For x=0 To 31
              cc.a=PeekA(*filemem+hl+x)
              bb.a=(cy*128)|(cc>>1)
              cy=cc&1
              PokeA(*tmpbuf+hl+x,bb)
            Next x
            For x=0 To 31
              PokeA( *tmpbuf+hl+x,PeekA(*tmpbuf+hl+x)|PeekA(*filemem+hl+x) )
            Next x
            hl=down_hl(hl)
          Next y
          CopyMemory(*tmpbuf,*filemem,6144)
          
          ;scroll left
          hl.u=0  
          For y=0 To 191
            cy.a=0
            For x=31 To 0 Step -1
              cc.a=PeekA(*filemem+hl+x)
              bb.a=cy|(cc<<1)
              cy=(cc&128)>>7
              PokeA(*tmpbuf+hl+x,bb)
            Next x
            For x=0 To 31
              PokeA( *tmpbuf+hl+x,PeekA(*tmpbuf+hl+x)|PeekA(*filemem+hl+x) )
            Next x
            hl=down_hl(hl)
          Next y
          CopyMemory(*tmpbuf,*filemem,6144)
          ;scroll down
          hl.u=0
          de.u=256
          For y=0 To 190
            For x=0 To 31
              PokeA( *filemem+hl+x,PeekA(*filemem+hl+x)|PeekA(*tmpbuf+de+x) )
            Next x
            hl=down_hl(hl)
            de=down_hl(de)
          Next y
          CopyMemory( *filemem,*tmpbuf,6144 )
          ;scroll up
          For y=191 To 1 Step -1
            hl=scradrs(y-1)
            de=scradrs(y)
            For x=0 To 31
              PokeA( *tmpbuf+de+x,PeekA(*tmpbuf+de+x)|PeekA(*filemem+hl+x) )
            Next x
          Next y
          CopyMemory(*tmpbuf,*filemem,6144)
          drawzx(-1,-1)
          
        Case #MENU_CONTOUR
          CopyMemory (*filemem,*filemem+6912,6912)
          For y=1 To 191
            For x=0 To 255

              cc.a=0
              If Not getpixel(x,y)
                If getpixel(x-1,y):cc+1:EndIf
                If getpixel(x+1,y):cc+1:EndIf
                If getpixel(x,y-1):cc+1:EndIf
                
                If (y<>191) And getpixel(x,y+1)
                  cc+1
                EndIf
                
                If cc<>0
;                   h.a=( y & %00000111 )
;                   h=h|((y>>3)&%00011000)
;                   l.a=(y<<2)& %11100000
;                   l=l|( (x>>3)&%00011111 )
;                   bb.a=PeekA(*tmpbuf+h*256+l)
;                   bb=bb|(128>>(x&7))
;                  PokeA(*tmpbuf+h*256+l,bb)
                   bb.a=PeekA(*tmpbuf+scra(y)+x>>3)
                   bb=bb|(128>>(x&7))
                  PokeA(*tmpbuf+scra(y)+x>>3,bb)

                EndIf
              EndIf
            Next x
          Next y
          CopyMemory(*tmpbuf,*filemem,6144)
          drawzx(-1,-1)
          
        Case #MENU_SPLIT
          If filetosave<>""
            f2s.s=Mid( filetosave,1,Len(filetosave)-Len("."+GetExtensionPart(filetosave)) );;filetosave;GetFilePart(filetosave)
            CreateFile(0,f2s+".screen")
            WriteData(0,*filemem,6144)
            CloseFile(0)
            CreateFile(0,f2s+".attr")
            WriteData(0,*filemem+6144,768)
            CloseFile(0)
          Else
            MessageRequester("Error","load screen first!", #PB_MessageRequester_Ok)
          EndIf
          
        Case #MENU_INVERT
          CopyMemory (*filemem,*filemem+6912,6912)
          For i=0 To 6143
            a1.a=PeekA(*filemem+i)
            PokeA(*filemem+i,a1!255)
          Next i
          For i=0 To 767
            a1.a=PeekA(*filemem+i+6144)
            a1=(a1&192)|((a1&7)<<3)|((a1&56)>>3)
            PokeA(*filemem+i+6144,a1)
          Next i
          drawzx(-1,-1)
          ;------------------Optimize NEW first------------------
        Case #MENU_OPTIMI2
          CopyMemory (*filemem,*filemem+6912,6912)
          
          PokeA( *filemem+6912*2,PeekA(*filemem+6144) )
          rege.a=1
          regd.a=0
          For i=1 To 768
            PokeA( *filemem+6912*2+i,PeekA(*filemem+6144+i) )
            
            If PeekA(*filemem+6144+i)&7=(%0011100&PeekA(*filemem+6144+i-1))>>3
              ddisp=rege+2048*regd;i&255+2048*(i&$F00>>16); -1
              For k=0 To 7
                a1.a=PeekA(*filemem+ddisp+k*256)
                PokeA(*filemem+ddisp+k*256,255-a1)
              Next k
              a2.a=PeekA(*filemem+6144+i)
              a2=a2&$C0+(a2&7)<<3+(a2&$38)>>3
              PokeA( *filemem+6912*2+i,a2 )
            EndIf
            rege+1
            If rege=0
              regd+1
            EndIf
          Next i
          CopyMemory (*filemem+6912*2,*filemem+6144,768)
          
          ; phase 2
          ;         PokeA( *filemem+6912*2,PeekA(*filemem+6144) )
          ;         rege.a=1
          ;         regd.a=0
          ;         For i=1 To 768
          ;           PokeA( *filemem+6912*2+i,PeekA(*filemem+6144+i) )
          ; 
          ;           If PeekA(*filemem+6144+i-1)&7=(%0011100&PeekA(*filemem+6144+i))>>3
          ;             ddisp=rege+2048*regd;i&255+2048*(i&$F00>>16); -1
          ;             For k=0 To 7
          ;               a1.a=PeekA(*filemem+ddisp+k*256)
          ;               PokeA(*filemem+ddisp+k*256,255-a1)
          ;             Next k
          ;             a2.a=PeekA(*filemem+6144+i)
          ;             a2=a2&$C0+(a2&7)<<3+(a2&$38)>>3
          ;             PokeA( *filemem+6912*2+i,a2 )
          ;           EndIf
          ;           rege+1
          ;           If rege=0
          ;             regd+1
          ;           EndIf
          ;         Next i
          ;         CopyMemory (*filemem+6912*2,*filemem+6144,768)
          
          
          drawzx(-1,-1)
          
        Case #MENU_OPTIMI
          CopyMemory (*filemem,*filemem+6912,6912)
          For y1=0 To 23
            For x1=0 To 30
              ii=x1+y1*32
              ;      ,        ( ),  .
              a1.a=PeekA(*filemem+6144+ii+1);
              a2.a=PeekA(*filemem+6144+ii)  ;
              If (a2&7=(a1&56)>>3) Or (a1&7=(a2&56)>>3)
                ;;Debug "x:"+Str(x1)+",y:"+Str(y1)
                ;;Debug RSet(Bin(a1), 8, "0")
                a1=(a1&192)|((a1&7)<<3)|((a1&56)>>3)
                ;;Debug RSet(Bin(a1), 8, "0")
                PokeA(*filemem+6144+ii+1,a1)
                xx=x1+1
                yy=y1
                disp.u=((yy&7)*32)|xx+256*(yy&24)
                For i=0 To 7
                  sc.a=PeekA(*filemem+disp+i*256)
                  PokeA(*filemem+disp+i*256,255!sc)
                Next i
                ;?x1=x1+1
              EndIf
            Next x1
          Next y1
          drawzx(-1,-1)
          
        Case #MENU_OPEN;open
          Pattern$ = "All files (*.*)|*.*|ZX Spectrum screens (*.scr)|*.scr|ZX Hobetf (*.$C)|*.$C"
          File$ = OpenFileRequester("Please choose file to load", "", Pattern$, 1)
          If File$
            
            fis=FileSize(File$)
            If FileSize(File$)=6912 Or FileSize(File$)=6929
              ReadFile(0,File$)
              howtosave=#save_scr
              If (SelectedFilePattern()=2) Or (FileSize(File$)=6929 And SelectedFilePattern()=0)
                howtosave=#save_hob
                FileSeek(0,$11)
              EndIf
              ReadData(0,*filemem,6912)
              CopyMemory (*filemem,*filemem+6912,6912)
              CloseFile(0)
              drawzx(-1,-1)
              filetosave=File$
            Else
               MessageRequester("Error","this is not ZX Spectrum picture!", #PB_MessageRequester_Ok)
            EndIf
            
          Else
            ;MessageRequester("Information", "The requester was canceled.", 0) 
          EndIf
          
          ;----------------------saveas
        Case #MENU_SAVEAS
          Pattern$ = "All files (*.*)|*.*|ZX Spectrum screens (*.scr)|*.scr|ZX Hobeta (*.$C)|*.$C"
          File$ = OpenFileRequester("Please choose file to load", "", Pattern$, 1)
          
          ;  Debug file$
          If file$
            Select SelectedFilePattern()
              Case 0: ;anyfiles
              Case 1: ;scr
                filetosave=addext(file$,"scr")
                ;Debug filetosave
                howtosave=#save_scr
                If CreateFile(0,filetosave)
                  WriteData(0,*filemem,6912)
                  CloseFile(0)
                Else
                  MessageRequester("Error","error saving file!"+Chr($0A)+filetosave, #PB_MessageRequester_Ok)
                EndIf
                
              Case 2: ;hobeta
                howtosave=#save_hob
                filetosave=addext(file$,"$c")
                If CreateFile(0,filetosave)
                  zxna.s=GetFilePart(filetosave,#PB_FileSystem_NoExtension)
                  While Len(zxna)<8
                    zxna=zxna+" "
                  Wend
                  zxna=zxna+"C"
                  For i=1 To 9
                    hobh(i-1)=Asc( Mid(zxna,i,1) )
                  Next i
                  hobh(9)=0:hobh(10)=$40
                  hobh(11)=0:hobh(12)=$1B
                  hobh(13)=0:hobh(14)=$1B
                  ;calc checksum
                  chk.u=0
                  ;for (i=0; i<=14; CheckSum = CheckSum + (header[i] * 257) + i, i++);
                  For i=0 To 14
                    chk=chk+i+257*hobh(i)
                    WriteAsciiCharacter(0,hobh(i))
                  Next i
                  ;Debug Hex(chk)
                  WriteWord(0,chk)
                  WriteData(0,*filemem,6912)
                  CloseFile(0)
                Else
                  MessageRequester("Error","error saving file!"+Chr($0A)+filetosave, #PB_MessageRequester_Ok)
                EndIf
            EndSelect
          EndIf
          
        Case #MENU_SAVE
          Select howtosave
            Case #save_none:MessageRequester("Information","Ooops", #PB_MessageRequester_Ok)
            Case #save_scr
              If CreateFile(0,filetosave)
                WriteData(0,*filemem,6912)
                CloseFile(0)
              Else
                MessageRequester("Error","error saving file!", #PB_MessageRequester_Ok)
              EndIf
            Case #save_hob:;MessageRequester("Information","Not implemented Yet", #PB_MessageRequester_Ok)
              If OpenFile(0,filetosave)
                FileSeek(0,$11)
                WriteData(0,*filemem,6912)
                CloseFile(0)
              Else
                MessageRequester("Error","error saving file!", #PB_MessageRequester_Ok)
              EndIf
            Case #save_trd:;MessageRequester("Information","Not implemented Yet", #PB_MessageRequester_Ok);trdfs
              If trdofs<>-1
                If OpenFile(0,trdf)
                  FileSeek(0,trdofs)
                  WriteData(0,*filemem,6912)
                  CloseFile(0)
                Else
                  MessageRequester("Error","error saving file!"+Chr(10)+trdf, #PB_MessageRequester_Ok)
                EndIf
                
              EndIf
              
          EndSelect
          
        Case #MENU_QUIT
          Event=#PB_Event_CloseWindow
      EndSelect
      ;  EndIf
      
      ;EndSelect
      
      ;---------------------------Drag\n'drop
    Case #PB_Event_GadgetDrop
      
      ;  If Event=#PB_Event_GadgetDrop
      Select EventGadget()
          
        Case #Image_0,#Image_1
          trdf=""
          Files$ = EventDropFiles()
          File$ = StringField(Files$, 1, Chr(10))
          
          fis=FileSize(file$)
          If fis=6912  Or fis=6929  Or fis=6144
          ;If FileSize(file$)=6912  Or FileSize(File$)=6929
            ReadFile(0,File$)
            howtosave=#save_scr
            If FileSize(File$)=6929
              FileSeek(0,$11)
              howtosave=#save_hob
              fis=6912
            EndIf
            ReadData(0,*filemem,fis)
            CopyMemory (*filemem,*filemem+6912,6912)
            CloseFile(0)
            drawzx(-1,-1)
            filetosave=file$
          Else
            MessageRequester("Error","this is not ZX Spectrum picture!", #PB_MessageRequester_Ok)
          EndIf
        Case #dsk
          ClearGadgetItems(#dsk)
          isf.a=GetGadgetState(#fltr)
          Files$ = EventDropFiles()
          trdf = StringField(Files$, 1, Chr(10))
          ReadFile(1,trdf)
          ReadData(1,*track,4096)
          CloseFile(1)
          
          disp=0
          While PeekA(*track+disp)<>0
            n.s=PeekS(*track+disp,8,#PB_Ascii)
            sta.u=PeekU(*track+disp+9)
            siz.u=PeekU(*track+disp+11)
            
            startt.a=PeekA(*track+disp+15);start track
            starts.a=PeekA(*track+disp+14);start sector
            type.a=PeekA(*track+disp+8)
            
            If isf And siz=6912
              AddGadgetItem(#dsk, -1, n+Chr(10)+Chr(type)+Chr(10)+Str(sta)+Chr(10)+Str(siz)+Chr(10)+Str(startt)+Chr(10)+Str(starts))
            EndIf
            If Not isf
              AddGadgetItem(#dsk, -1, n+Chr(10)+Chr(type)+Chr(10)+Str(sta)+Chr(10)+Str(siz)+Chr(10)+Str(startt)+Chr(10)+Str(starts))
            EndIf
            disp+16
          Wend
      EndSelect
      
      ;  EndIf
      
  EndSelect
  
  ;------draw picture onclick
  
  Select  EventGadget()
    Case  #combo_p1
      If EventType()=#PB_EventType_Change
        ind=GetGadgetState(#combo_p1)
        If ind>=0
          SetGadgetText(#Field_b1,Str(ind))
        EndIf
      EndIf
      
    Case  #combo_p2
      If EventType()=#PB_EventType_Change
        ind=GetGadgetState(#combo_p2)
        If ind>=0
          SetGadgetText(#Field_b2,Str(ind))
        EndIf
      EndIf
      
    Case  #dsk  
      Select EventType()
        Case #PB_EventType_LeftDoubleClick
          CopyMemory(*track,*filemem,6912)
          SetGadgetState(#panel,0)
          howtosave=#save_trd
          drawzx(-1,-1)
        Case #PB_EventType_LeftClick
          tpos=GetGadgetState(#dsk)
          If tpos<>-1
            startt=Val( GetGadgetItemText(#dsk, tpos,4) )
            starts=Val( GetGadgetItemText(#dsk, tpos,5) )
            ReadFile(1,trdf)
            FileSeek(1,startt*4096+starts*256)
            trdofs=startt*4096+starts*256
            ReadData(1,*track,6912)
            CloseFile(1)
            draw_zx()
          EndIf
      EndSelect
      ; EndIf
      
    Case #CheckBox_Grid
      ;  If Event = #PB_Event_Gadget And EventGadget() = #CheckBox_Grid
      drawzx(-1,-1)
      ;  EndIf
      
    Case #radio_n,#radio_i,#radio_p
      drawzx(-1,-1);Debug "radio"
      
      ;---scroll buttons
    Case #bsd
      
      ;If Event = #WM_LBUTTONDOWN 
      CopyMemory (*filemem,*filemem+6912,6912)
      For xx=0 To 31
        For tt=0 To 7
          bb=PeekA(*filemem+xx+scra(191))
          For yy=191 To 1 Step -1
            PokeA(*filemem+xx+scra(yy), PeekA(*filemem+xx+scra(yy-1)) )
          Next yy
          PokeA(*filemem+xx,bb)
        Next tt
      Next xx
      
      For xx=0 To 31
        bb=PeekA(*filemem+6144+xx+23*32)
        For yy=23 To 1 Step -1
          PokeA( *filemem+6144+xx+yy*32, PeekA(*filemem+6144+xx+yy*32-32) )
        Next yy
        PokeA(*filemem+6144+xx,bb)
      Next xx
      
      drawzx(-1,-1)
      e=WaitWindowEvent()
      e=WaitWindowEvent()
      ;EndIf
      ;Sleep_(500)
      
    Case #bsu
      CopyMemory (*filemem,*filemem+6912,6912)
      For xx=0 To 31
        For tt=0 To 7
          bb.a=PeekA(*filemem+xx)
          For yy=0 To 190
            PokeA( *filemem+xx+scra(yy),PeekA(*filemem+xx+scra(yy+1)) )
          Next yy
          PokeA(*filemem+xx+scra(191),bb)
        Next tt
      Next xx  
      
      For xx=0 To 31
        bb=PeekA(*filemem+6144+xx)
        For yy=0 To 22
          PokeA(*filemem+6144+yy*32+xx,PeekA(*filemem+6144+yy*32+32+xx) )
        Next yy
        PokeA(*filemem+6144+xx+23*32,bb)
      Next xx
      
      e=WaitWindowEvent()
      e=WaitWindowEvent()
      drawzx(-1,-1)
      
    Case #bsr
      CopyMemory (*filemem,*filemem+6912,6912)
      For yy=0 To 191
        bb.a=PeekA(*filemem+scra(yy)+31)
        For xx=31 To 1 Step -1
          PokeA( *filemem+scra(yy)+xx,PeekA(*filemem+scra(yy)+xx-1) )
        Next xx
        PokeA(*filemem+scra(yy),bb)
      Next yy
      
      For yy=0 To 23
        bb=PeekA(*filemem+6144+yy*32+31)
        For xx=31 To 1 Step -1
          PokeA( *filemem+yy*32+xx+6144,PeekA(*filemem+6144+yy*32+xx-1) )
        Next xx
        PokeB(*filemem+yy*32+6144,bb)
      Next yy
      
      e=WaitWindowEvent()
      e=WaitWindowEvent()
      drawzx(-1,-1)
      
    Case #bsl
      CopyMemory (*filemem,*filemem+6912,6912)
      For yy=0 To 191
        bb.a=PeekA(*filemem+scra(yy))
        For xx=0 To 31
          PokeA(*filemem+scra(yy)+xx,PeekA(*filemem+scra(yy)+xx+1) )
        Next xx
        PokeA(*filemem+scra(yy)+31,bb)
      Next yy
      
      For yy=0 To 23
        bb=PeekA(*filemem+6144+yy*32)
        For xx=0 To 31
          PokeA(*filemem+6144+xx+yy*32,PeekA(*filemem+6144+xx+1+yy*32))
        Next xx
        PokeA(*filemem+6144+yy*32+31,bb)
      Next yy
      e=WaitWindowEvent()
      e=WaitWindowEvent()
      drawzx(-1,-1)
      
      ;---byte operations
    Case #btn_go
      If EventType()=#PB_EventType_LeftClick
        ;Debug "go"
        CopyMemory (*filemem,*filemem+6912,6912)
        dodo=GetGadgetState(#combo_b1b2)
        b1$=GetGadgetText(#Field_b1)
        b2$=GetGadgetText(#Field_b2)
        b1.a=Val(b1$)
        b2.a=Val(b2$)
        For i=0 To 767
          a.a=PeekA(*filemem+i+6144)
          Select dodo
            Case 8:
              a=b1
            Case 1:
              If a=b1:a=b2:EndIf
            Case 2:;AND
              a=a&b2
            Case 3:;OR
              a=a|b2
            Case 4:;EOR
              a=a!b2
            Case 5:;ink
              If a&7=b1
                a=(a&$F8)|b2
              EndIf
            Case 6:;paper
              If a&$38=b1*8
                a=(a&%11000111)|(b2*8)
              EndIf
            Case 7:;paper+ink
              If a&7=b1
                a=(a&$F8)|b2
              EndIf
              
              If a&$38=b1*8
                a=(a&%11000111)|(b2*8)
              EndIf
          EndSelect
          PokeA(*filemem+i+6144,a)
        Next i
        drawzx(-1,-1)
        ;  EndIf
        
      EndIf
      
  EndSelect  
  
  If Event = #PB_Event_Gadget And ((EventGadget() = #Image_0) Or (EventGadget() = #Image_1))
    
    If EventType() = #PB_EventType_LeftButtonDown Or EventType() = #PB_EventType_RightButtonDown; And GetGadgetAttribute(EventGadget(), #PB_Canvas_Buttons) & #PB_Canvas_LeftButton
      x = GetGadgetAttribute(EventGadget(), #PB_Canvas_MouseX)>>4
      y = GetGadgetAttribute(EventGadget(), #PB_Canvas_MouseY)>>4
      ; Get screen address
      ; D = Y character position
      ; E = X character position
      ; Returns address in DE
      ;
      ; Get_Char_Address:   LD A,D
      ;             And %00000111
      ;             RRA
      ;             RRA
      ;             RRA
      ;             RRA
      ;             Or E
      ;             LD E,A
      ;             LD A,D
      ;             And %00011000
      ;             Or %01000000
      ;             LD D,A
      ;             RET             ; Returns screen address in DE 
      
      xb=x
      xe=x
      If EventType() = #PB_EventType_RightButtonDown
        xe=31
      EndIf
      For x=xb To xe
        disp.u=((y&7)*32)|x+256*(y&24)
        
        For i=0 To 7
          sc.a=PeekB(*filemem+disp+i*256)
          PokeB(*filemem+disp+i*256,255-sc)
        Next i
        
        sc.a=PeekB(*filemem+6144+y*32+x)
        sc.a=(sc&192)|((sc&7)<<3)|((sc&56)>>3)
        PokeB(*filemem+6144+y*32+x,sc)
        
      Next x
      drawzx(x,y)
    EndIf
    
    ;----Mouse Move
    If EventType() = #PB_EventType_MouseMove
      ;      Debug "mouse move"
      x = GetGadgetAttribute(EventGadget(), #PB_Canvas_MouseX)>>4
      y = GetGadgetAttribute(EventGadget(), #PB_Canvas_MouseY)>>4
      
      zxa.s=RSet(Bin(PeekB(*filemem+6144+y*32+x)), 8, "0")
      
      zxa=Mid(zxa,0,2)+":"+Mid(zxa,3,3)+":"+Mid(zxa,6,3)
      SetWindowTitle(0,"x:"+Str(x)+" y:"+Str(y)+" attribute:"+zxa+" file:"+filetosave)
      drawzx(x,y)
    EndIf
  EndIf
  
Until Event=#PB_Event_CloseWindow

FreeMemory(*track)
FreeMemory(*tmpbuf)
FreeMemory(*filemem)

DataSection
  isl:
  IncludeBinary "bleft.ico";;;"bleft.png"
  isr:
  IncludeBinary "bright.ico";;"bright.png"
  isu:
  IncludeBinary "bup.ico";;"bup.png"
  isd:
  IncludeBinary"bdown.ico";;"bdown.png"
  

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 924
; FirstLine = 909
; Folding = --
; EnableXP
; UseIcon = zxscr.ico
; Executable = scrop1_0j.exe
; CommandLine = chaos_doodle_001_undefined_small.scr
; Watchlist = x1;y1;a1